/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#ifndef __GUI__
#define __GUI__

#include "sizedefs.h"
#include "uclock.h"

#define MAIN_MENU       0
#define CHILD_MENU      1

#define M_PLAIN         1
#define M_MARK          2
#define M_SEL           3
#define M_LINK          4
#define M_SEP           5

#define DW_DOWN         0
#define DW_UP           1
#define DW_TAB          2
#define DW_STAY         3
#define DW_DONE         4
#define DW_ESC          5

#define DA_NORMAL       0
#define DA_DIRECT       1

#define D_TEXT          0
#define D_SEL           1
#define D_BUTTON        2
#define D_LIST          3
#define D_SELFILE       4

#define DB_OK           0
#define DB_CANCEL       1
#define DB_FUNC         2

#define F_STRING        0
#define F_LONG          1
#define F_FLOAT         2

#define _A_DRIVE        0x80


extern u_long           NormalCharSet[];
extern u_char           MousePointer[];
extern u_char           CloseButtonBitmap[];


typedef struct {

        char                   *v_buffer;
        void                  (*flip_vga)();
        u_long                  w, h;
        u_long                  vga_w, vga_h;
        u_long                  bpp;
        u_long                 *char_set;
        u_long                  show_mouse;
        struct _menu_gui_      *menu_gui;
        struct _bitmap_        *backg_copy;
        u_long                  backg_flg;

        u_long                  white_color;
        u_long                  black_color;
        u_long                  menu_color;
        u_long                  font_l_color;
        u_long                  font_h_color;
        u_long                  dialog_color;
        u_long                  tdialog_color;

} GUISystem;


#define WHITECOLOR              gui_system->white_color
#define BLACKCOLOR              gui_system->black_color
#define MENUCOLOR               gui_system->menu_color
#define FONTLCOLOR              gui_system->font_l_color
#define FONTHCOLOR              gui_system->font_h_color
#define DIALOGCOLOR             gui_system->dialog_color
#define TDIALOGCOLOR            gui_system->tdialog_color


typedef struct {

        unsigned        cnt;
        int             size_st;
        void           *dtos;

} ListObj;


ListObj *OpenListObj (int size_st);
void AddListObj (ListObj *list_obj, void *dtos);
void DelListObj (ListObj *list_obj, u_char *item);
void CeroListObj (ListObj *list_obj);
void FreeListObj (ListObj *list_obj);



extern struct _mouse_   mouse;

#define  M_LDOWN        ( mouse.buttonstatus & 0x01 )
#define  M_RDOWN        ( mouse.buttonstatus & 0x02 )


struct _mouse_ {

            u_long      x, y;
            u_long      buttonstatus;
            u_long      eventcount;
            u_long      event;
            u_long      left_presses;
            u_long      right_presses;
            u_long      left_was_pressed;
            u_long      right_was_pressed;
            long        last_l_press;
            long        last_r_press;
            long        check_time;
};

extern u_long           mouse_present;

int GUIMouseReset (void);
void GUIMouseSetPos (u_long x, u_long y);
void GUIMouseOn (void);
void GUIMouseOff (void);
void GUIMouseMax (u_long min_h, u_long max_h, u_long min_v, u_long max_v);
void GUIMouseInit (void);
void GUIGiveMousePos (GUISystem *gui_system, u_long *x, u_long *y);


typedef struct _bitmap_ {

        GUISystem      *gui_system;
        char           *bit_zone;
        u_long          w;
        u_long          h;

} Bitmap;


typedef struct _scrl_bar_ {

        struct         _dialog_gui_ *dialog_gui;
        u_long          y;
        u_long          x;
        u_long          h;
        long            pos;
        u_long          max;
        u_long          paso;
        long            pos_bar;
        double          hm;

} ScrlBar;


Bitmap *GetBitmapGUI (GUISystem *gui_system, u_long x, u_long y,
                      u_long w, u_long h);
void PutFreeBitZoneGUI (Bitmap *bitmap, u_long x, u_long y);
void PutBitZoneGUI (Bitmap *bitmap, u_long x, u_long y);
void FreeBitmapGUI (Bitmap *bitmap);


typedef struct {

        u_long                  control;
        char                    title[80];
        u_long                  type;
        void                  (*func_call)();
        u_char                 *mark_var;
        u_char                 *sel_var;
        u_long                  sel_pos;
        struct _menu_gui_      *menu_link;

} MenuGUIItem;


typedef struct _menu_gui_ {

        GUISystem      *gui_system;
        u_long          y, x;
        u_long          yf, xf;
        u_long          w, h;
        ListObj        *menu_item;
        long            pos_menu;
        u_long          items;
        u_long          exit;

} MenuGUI;


u_long RotateLong (u_long target);
#pragma aux RotateLong=\
        "bswap eax    "\
        parm [eax] \
        value [eax];

GUISystem *InitGUISystem (u_long w, u_long h, char *v_buffer,
                          void (*flip_vga)(), u_long vga_w, u_long vga_h);
void FreeGUISystem (GUISystem *gui_system);

void ShowGUI (GUISystem *gui_system);
void SetBackgGUI (GUISystem *gui_system);
void FreeBackgGUI (GUISystem *gui_system);
void Draw16x16BitmapGUI (GUISystem *gui_system, u_long x, u_long y,
                       u_char *bitmap);
void DrawBitmapGUI (GUISystem *gui_system, u_long x, u_long y, u_char *bitmap,
                    u_long w, u_long h);
void DrawTextGUI (GUISystem *gui_system, u_long x, u_long y, char *to_draw);
void DrawTextGUIColor (GUISystem *gui_system, u_long x, u_long y, u_long col,
                       char *to_draw);
u_long CntTextGUI (GUISystem *gui_system, char *to_draw);
void DrawRectangleGUI (GUISystem *gui_system, u_long x, u_long y, u_long xf,
                       u_long yf, u_long color);
void DrawRevRectangleGUI (GUISystem *gui_system, u_long x, u_long y, u_long xf,
                       u_long yf, u_long color);
void DrawPlainRectangleGUI (GUISystem *gui_system, u_long x, u_long y,
                            u_long xf, u_long yf, u_long color);

MenuGUI *MakeMenuGUI (GUISystem *gui_system, u_long w, u_long h);
void FreeMenuGUI (MenuGUI *menu_gui);
void AddPlainMenuGUI (MenuGUI *menu_gui, char *title, void (*func_call)());
void AddMarkMenuGUI (MenuGUI *menu_gui, char *title, u_char *mark_var);
void AddSelMenuGUI (MenuGUI *menu_gui, char *title, u_char *sel_var,
                    u_long sel_pos);
void AddLinkMenuGUI (MenuGUI *menu_gui, char *title, MenuGUI *menu_link);
void AddSepMenuGUI (MenuGUI *menu_gui);
void RunMenuGUI (MenuGUI *menu_gui, u_long x, u_long y, u_long type);


typedef struct {

        u_long                  control;
        u_long                  type;
        u_long                  access;
        u_long                  pos;
        void                   *dtos;
        void                   *deriv_data;
        struct _dialog_gui_    *dialog_gui;

} DialogGUIItem;

typedef struct _dialog_gui_ {

        GUISystem      *gui_system;
        long            x, y;
        long            xf, yf;
        u_long          w, h;
        ListObj        *dialog_item;
        long            pos_dlg;
        u_long          items;
        u_long          way;
        Bitmap         *background;
        void           *parse_data;
        char            title[80];

} DialogGUI;

typedef struct {

        u_long          x, y;
        u_long          col;
        char            text[160];

} TextDlg;

typedef struct {

        u_long          control;
        u_long          x, y;
        u_long          pos;
        char            text[80];

} SelItemDlg;

typedef struct {

        u_long         *var_sel;
        u_long          x, y;
        u_long          w, h;
        ListObj        *sel_item;
        u_long          items;
        u_char          title[80];

} SelDlg;

typedef struct {

        u_long          type;
        u_long          x, y;
        u_long          w;
        void          (*func_call)();
        u_char          text[40];

} ButtonDlg;

typedef struct {

        u_long          x, y;
        u_long          w, h;
        u_long          f_line;
        u_long          m_line;
        u_long          n_dtos;
        long            pos;
        u_long          size_dtos;
        u_long          d_click;
        u_long        (*func_call)(DialogGUIItem *, u_long *);
        void           *dtos;
        ListObj        *list_item;
        ListObj        *list_dtos;
        ScrlBar        *scrl_bar;

} ListDlg;

typedef struct {

        u_long          control;
        u_long          type;
        u_long          lon;
        char            msg[80];
        void           *var;

} ItemListDlg;

typedef struct _file_info_ {

        u_long          control;
        char            name[80];
        u_long          size;
        u_long          attr;

} FileInfo;

typedef struct {

        ListDlg        *list_dlg;
        FileInfo        file_info;
        char            wildcards[80];
        char            path[320];
        char            first_path[320];

} SelFileDlg;


DialogGUI *MakeDialogGUI (GUISystem *gui_system, char *title, u_long w,
                          u_long h);
void FreeDialogGUI (DialogGUI *dialog_gui);
void AddDialogGUI (DialogGUI *dialog_gui, u_long type, void *dtos);
void DrawDialogGUI (DialogGUI *dialog_gui, u_long x, u_long y);
u_long RunDialogGUI (DialogGUI *dialog_gui);

TextDlg *CTextDlg (u_long x, u_long y, u_long col, char *text);
void DTextDlg (DialogGUIItem *dialog_item);

SelDlg *CSelDlg (u_long x, u_long y, u_long w, u_long h,
                 u_long *var_sel, char *title);
void AddSelDlg (SelDlg *sel_dlg, u_long x, u_long y, char *text);
void DSelDlg (DialogGUIItem *dialog_item);
void FSelDlg (DialogGUIItem *dialog_item);

ButtonDlg *CButtonDlg (u_long x, u_long y, u_long w, char *text,
                       u_long type, void (*func_call)());
void DButtonDlg (DialogGUIItem *dialog_item);
u_long RButtonDlg (DialogGUIItem *dialog_item);
u_long MButtonDlg (DialogGUIItem *dialog_item);

ListDlg *CListDlg (u_long x, u_long y, u_long w, u_long h, void *dtos,
                   u_long size_dtos);
void AddItemListDlg (ListDlg *list_dlg, char *msg, u_long type, u_long lon,
                     void *var);
void AddDtosListDlg (ListDlg *list_dlg, void *dtos);
void DListDlg (DialogGUIItem *dialog_item);
u_long RListDlg (DialogGUIItem *dialog_item);
u_long MListDlg (DialogGUIItem *dialog_item);
void AListDlg (DialogGUIItem *dialog_item);
void FListDlg (DialogGUIItem *dialog_item);

SelFileDlg *CSelFileDlg (u_long x, u_long y, u_long w, u_long h,
                         char *path, char *wildcards);
void DSelFileDlg (DialogGUIItem *dialog_item);
u_long RSelFileDlg (DialogGUIItem *dialog_item);
u_long MSelFileDlg (DialogGUIItem *dialog_item);
void ASelFileDlg (DialogGUIItem *dialog_item);
void FSelFileDlg (DialogGUIItem *dialog_item);

ScrlBar *MakeScrlBar (DialogGUI *dialog_gui, u_long x, u_long y, u_long h,
                      u_long paso);
void ChScrlBar (ScrlBar *scrl_bar, u_long pos, u_long max);
void DrawScrlBar (ScrlBar *scrl_bar);
u_long CheckScrlBar (ScrlBar *scrl_bar);
void FreeScrlBar (ScrlBar *scrl_bar);

FLAG MessageBox (GUISystem *gui_system, char *message, u_long buttons);

void SetPalGUI (u_char *pal_ptr, u_long n_cols);
void LoadPCXBackgGUI (GUISystem *gui_system, char *file);
void PutPCXBackgGUI (GUISystem *gui_system, char *pcx_ptr);

void FormatStrGUI (char *dest, u_long type, void *var, u_long lon);
void WaitKey (void);
u_long SKbHited (void);
u_long KbHited (void);

#endif
