/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


// Este fue el primer intento de hacer el 68K en C, despues lo use para
// el debugger.


#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include "vga.h"
#include "header.h"
#include "st0rm.h"
#include "m68k.h"
#include "m68misc.h"
#include "misc.h"
#include "m68deb.h"



void SayGoodBye (OperDef *oper_def);
void SayBadAddr (OperDef *oper_def);

char    OpNotImp (OperDef *oper_def);

char    OpAdd (OperDef *oper_def);
char    OpAdda (OperDef *oper_def);
char    OpAddi (OperDef *oper_def);
char    OpAddq (OperDef *oper_def);
char    OpAnd (OperDef *oper_def);
char    OpAndi (OperDef *oper_def);
char    OpBxx (OperDef *oper_def);
char    OpBra (OperDef *oper_def);
char    OpBsr (OperDef *oper_def);
char    OpBtstd (OperDef *oper_def);
char    OpBtstr (OperDef *oper_def);
char    OpChk (OperDef *oper_def);
char    OpClr (OperDef *oper_def);
char    OpClrs (OperDef *oper_def);
char    OpCmp (OperDef *oper_def);
char    OpCmpm (OperDef *oper_def);
char    OpDbxx (OperDef *oper_def);
char    OpEor (OperDef *oper_def);
char    OpJmp (OperDef *oper_def);
char    OpJsr (OperDef *oper_def);
char    OpLea (OperDef *oper_def);
char    OpLink (OperDef *oper_def);
char    OpLslr (OperDef *oper_def);
char    OpMove (OperDef *oper_def);
char    OpMovea (OperDef *oper_def);
char    OpMovem (OperDef *oper_def);
char    OpMoveq (OperDef *oper_def);
char    OpMovetccr (OperDef *oper_def);
char    OpMovefsr (OperDef *oper_def);
char    OpMovetsr (OperDef *oper_def);
char    OpMoveusp (OperDef *oper_def);
char    OpNegx (OperDef *oper_def);
char    OpNop (OperDef *oper_def);
char    OpNot (OperDef *oper_def);
char    OpOr (OperDef *oper_def);
char    OpOri (OperDef *oper_def);
char    OpOritccr (OperDef *oper_def);
char    OpRts (OperDef *oper_def);
char    OpSxx (OperDef *oper_def);
char    OpSub (OperDef *oper_def);
char    OpSubq (OperDef *oper_def);
char    OpSubx (OperDef *oper_def);
char    OpTst (OperDef *oper_def);
char    OpUnlk (OperDef *oper_def);


OperDef opers[] = {

{       0xc100,         0xf1f0,         "abcd",         OpNotImp },
{       0xd000,         0xf000,         "add",          OpAdd },
{       0xd000,         0xf000,         "adda",         OpAdda },
{       0x0600,         0xff00,         "addi",         OpAddi },
{       0x5000,         0xf100,         "addq",         OpAddq },
{       0xd100,         0xf130,         "addx",         OpNotImp },
{       0xc000,         0xf000,         "and",          OpAnd },
{       0x0200,         0xff00,         "andi",         OpAndi },
{       0xe100,         0xf118,         "asl r",        OpNotImp },
{       0xe000,         0xf118,         "asr r",        OpNotImp },
{       0xe1c0,         0xffc0,         "asl m",        OpNotImp },
{       0xe0c0,         0xffc0,         "asr m",        OpNotImp },
{       0x6400,         0xff00,         "bcc",          OpBxx },
{       0x6500,         0xff00,         "bcs",          OpBxx },
{       0x6600,         0xff00,         "bne",          OpBxx },
{       0x6700,         0xff00,         "beq",          OpBxx },
{       0x6800,         0xff00,         "bvc",          OpBxx },
{       0x6900,         0xff00,         "bvs",          OpBxx },
{       0x6a00,         0xff00,         "bpl",          OpBxx },
{       0x6b00,         0xff00,         "bmi",          OpBxx },
{       0x6c00,         0xff00,         "bge",          OpBxx },
{       0x6d00,         0xff00,         "blt",          OpBxx },
{       0x6e00,         0xff00,         "bgt",          OpBxx },
{       0x6f00,         0xff00,         "ble",          OpBxx },
{       0x0140,         0xf1c0,         "bchg",         OpNotImp },
{       0x0180,         0xf1c0,         "bclr r",       OpNotImp },
{       0x0880,         0xffc0,         "bclr d",       OpNotImp },
{       0x6000,         0xff00,         "bra",          OpBra },
{       0x01c0,         0xf1c0,         "bset",         OpNotImp },
{       0x6100,         0xff00,         "bsr",          OpBsr },
{       0x0100,         0xf1c0,         "btst r",       OpBtstr },
{       0x0800,         0xffc0,         "btst d",       OpBtstd },
{       0x4000,         0xf040,         "chk",          OpChk },
{       0x4200,         0xff00,         "clr",          OpClr },
{       0x9fcf,         0xffff,         "clr stack",    OpClrs },
{       0xb000,         0xf000,         "cmp",          OpCmp },
{       0x0c00,         0xff00,         "cmpi",         OpNotImp },
{       0xb108,         0xf138,         "cmpm",         OpCmpm },
{       0x51c8,         0xfff8,         "dbra",         OpDbxx },
{       0x54c8,         0xfff8,         "dbcc",         OpDbxx },
{       0x55c8,         0xfff8,         "dbcs",         OpDbxx },
{       0x56c8,         0xfff8,         "dbne",         OpDbxx },
{       0x57c8,         0xfff8,         "dbeq",         OpDbxx },
{       0x58c8,         0xfff8,         "dbvc",         OpDbxx },
{       0x59c8,         0xfff8,         "dbvs",         OpDbxx },
{       0x5ac8,         0xfff8,         "dbpl",         OpDbxx },
{       0x5bc8,         0xfff8,         "dbmi",         OpDbxx },
{       0x5cc8,         0xfff8,         "dbge",         OpDbxx },
{       0x5dc8,         0xfff8,         "dblt",         OpDbxx },
{       0x5ec8,         0xfff8,         "dbgt",         OpDbxx },
{       0x5fc8,         0xfff8,         "dble",         OpDbxx },
{       0x81c0,         0xf1c0,         "divs",         OpNotImp },
{       0x80c0,         0xf1c0,         "divu",         OpNotImp },
{       0xb000,         0xf000,         "eor",          OpEor },
{       0x0a00,         0xff00,         "eori",         OpNotImp },
{       0xc100,         0xf100,         "exg",          OpNotImp },
{       0x4800,         0xfe38,         "ext",          OpNotImp },
{       0x4afc,         0xffff,         "illegal",      OpNotImp },
{       0x4ec0,         0xffc0,         "jmp",          OpJmp },
{       0x4e80,         0xffc0,         "jsr",          OpJsr },
{       0x41c0,         0xf1c0,         "lea",          OpLea },
{       0x4e50,         0xfff8,         "link",         OpLink },
{       0xe108,         0xf118,         "lsl r",        OpLslr },
{       0xe008,         0xf118,         "lsr r",        OpNotImp },
{       0xe3c0,         0xffc0,         "lsl m",        OpNotImp },
{       0xe2c0,         0xffc0,         "lsr m",        OpNotImp },
{       0x0000,         0xc000,         "move",         OpMove },
{       0x0040,         0xc1c0,         "movea",        OpMovea },
{       0x46c0,         0xffc0,         "movetccr",     OpMovetccr },
{       0x44c0,         0xffc0,         "movetsr",      OpMovetsr },
{       0x40c0,         0xffc0,         "movefsr",      OpMovefsr },
{       0x4880,         0xfb80,         "movem",        OpMovem },
{       0x0008,         0xf038,         "movep",        OpNotImp },
{       0x7000,         0xf100,         "moveq",        OpMoveq },
{       0x4e60,         0xfff0,         "moveusp",      OpMoveusp },
{       0xc1c0,         0xf1c0,         "muls",         OpNotImp },
{       0xc0c0,         0xf1c0,         "mulu",         OpNotImp },
{       0x4800,         0xffc0,         "nbcd",         OpNotImp },
{       0x4400,         0xff00,         "neg",          OpNotImp },
{       0x4000,         0xff00,         "negx",         OpNegx },
{       0x4e71,         0xffff,         "nop",          OpNop },
{       0x4600,         0xff00,         "not",          OpNot },
{       0x8000,         0xf000,         "or",           OpOr },
{       0x0000,         0xff00,         "ori",          OpOri },  
{       0x007c,         0xffff,         "oritccr",      OpOritccr },  //0x003c
{       0x4840,         0xffc0,         "pea",          OpNotImp },
{       0xe118,         0xf118,         "rol r",        OpNotImp },
{       0xe018,         0xf118,         "ror r",        OpNotImp },
{       0xe7c0,         0xffc0,         "rol m",        OpNotImp },
{       0xe6c0,         0xffc0,         "ror m",        OpNotImp },
{       0xe110,         0xf118,         "roxl r",       OpNotImp },
{       0xe010,         0xf118,         "roxr r",       OpNotImp },
{       0xe5c0,         0xffc0,         "roxl m",       OpNotImp },
{       0xe4c0,         0xffc0,         "roxr m",       OpNotImp },
{       0x4e77,         0xffff,         "rtr",          OpNotImp },
{       0x4e75,         0xffff,         "rts",          OpRts },
{       0x8100,         0xf1f0,         "sbcd",         OpNotImp },
{       0x54c0,         0xffc0,         "scc",          OpSxx },
{       0x55c0,         0xffc0,         "scs",          OpSxx },
{       0x56c0,         0xffc0,         "sne",          OpSxx },
{       0x57c0,         0xffc0,         "seq",          OpSxx },
{       0x58c0,         0xffc0,         "svc",          OpSxx },
{       0x59c0,         0xffc0,         "svs",          OpSxx },
{       0x5ac0,         0xffc0,         "spl",          OpSxx },
{       0x5bc0,         0xffc0,         "smi",          OpSxx },
{       0x5cc0,         0xffc0,         "sge",          OpSxx },
{       0x5dc0,         0xffc0,         "slt",          OpSxx },
{       0x5ec0,         0xffc0,         "sgt",          OpSxx },
{       0x5fc0,         0xffc0,         "sle",          OpSxx },
{       0x9000,         0xf000,         "sub",          OpSub },
{       0x0400,         0xff00,         "subi",         OpNotImp },
{       0x5100,         0xf100,         "subq",         OpSubq },
{       0x9100,         0xf130,         "subx",         OpSubx },
{       0x4840,         0xfff8,         "swap",         OpNotImp },
{       0x4ac0,         0xffc0,         "tas",          OpNotImp },
{       0x4e40,         0xfff0,         "trap",         OpNotImp },
{       0x4e76,         0xffff,         "trapv",        OpNotImp },
{       0x4a00,         0xff00,         "tst",          OpTst },
{       0x4e58,         0xfff8,         "unlk",         OpUnlk },
{       0,              0,              NULL,           NULL }       

};


/*char RunCPU (void) {

  int                   cnt             = 0;
  u_short               tst;
  u_short               cmp             = GivePcOp ();


  while (1) {

        if (!opers[cnt].op_name) return 0;
        tst = cmp & opers[cnt].op_mask;

        if (tst == opers[cnt].op_code) {
                opers[cnt].op_called    = cmp;
                opers[cnt].debug        = 0;
                if (opers[cnt].op_func (&opers[cnt]))
                        return 1;
        }

        cnt++;
  }
}*/

char *GiveCodeName (void) {

  int                   cnt             = 0;
  u_short               tst;
  u_short               cmp             = GivePcOp ();


  while (1) {

        if (!opers[cnt].op_name) return NULL;
        tst = cmp & opers[cnt].op_mask;

        if (tst == opers[cnt].op_code) {
                opers[cnt].op_called    = cmp;
                opers[cnt].debug        = 1;
                if (opers[cnt].op_func (&opers[cnt]))
                        return (opers[cnt].op_name);
        }

        cnt++;
  }
}

char *GiveOpCodeName (u_short cmp) {

  int                   cnt             = 0;
  u_short               tst;
//u_short               cmp             = GivePcOp ();


  while (1) {

        if (!opers[cnt].op_name) return NULL;
        tst = cmp & opers[cnt].op_mask;

        if (tst == opers[cnt].op_code) {
                opers[cnt].op_called    = cmp;
                opers[cnt].debug        = 1;
                if (opers[cnt].op_func (&opers[cnt]))
                        return (opers[cnt].op_name);
        }

        cnt++;
  }
}

long GivePtrAddr (u_short e_addr, u_short size, OperDef *oper_def) {

  u_short       mode    = e_addr >> 3;
  u_short       reg     = e_addr & 0x0007;
  long          res;
  int           count;


  switch (size) {

        case 0  :
                  count = 1;
                  break;
        case 1  :
                  count = 2;
                  break;
        case 3  :
                  count = 4;
                  break;
        default :
                  count = 4;
                  break;
  }

  switch (mode) {

        case 0  :
                  return (LoadFromReg (regs.d[reg], size));
                  break;
        case 1  :
                  return (regs.a[reg]);
                  break;
        case 2  :
                  res = LoadMem (regs.a[reg], size);
                  return (res);
                  break;
        case 3  :
                  res = LoadMem (regs.a[reg], size);
                  regs.a[reg] += ((reg == 7) ? 2 : count);
                  return (res);
                  break;
        case 4  :
                  regs.a[reg] -= ((reg == 7) ? 2 : count);
                  res = LoadMem (regs.a[reg], size);
                  return (res);
                  break;
        case 5  :
                  res = LoadMem (((long)LoadWMem (regs.pc)) + \
                                 regs.a[reg], size);
                  regs.pc += 2;
                  return (res);
                  break;
        case 7  :
                  switch (reg) {

                        case 0  :
                                  res = LoadMem ((long)LoadWMem (regs.pc) & 0xffff, size);
                                  regs.pc += 2;
                                  return (res);
                                  break;
                        case 1  :
                                  res = LoadMem ((u_long)LoadLMem (regs.pc), size);
                                  regs.pc += 4;
                                  return (res);
                                  break;
                        case 2  :
                                  res = LoadMem (((long)LoadWMem (regs.pc)) + \
                                                 regs.pc, size);
                                  regs.pc += 2;
                                  return (res);
                                  break;
                        case 4  :
                                  res = LoadMem (regs.pc, size);
                                  regs.pc += count;
                                  return (res);
                                  break;
                        default :
                                  SayBadAddr (oper_def);
                                  break;
                  }

                  break;
                  
        default :
                  SayBadAddr (oper_def);
                  break;
  }

  return 0;
}

void PutPtrAddr (u_short e_addr, u_short size, long operand, OperDef *oper_def) {

  u_short       mode    = e_addr >> 3;
  u_short       reg     = e_addr & 0x0007;
  long          res;
  int           count;


  switch (size) {

        case 0  :
                  count = 1;
                  break;
        case 1  :
                  count = 2;
                  break;
        case 3  :
                  count = 4;
                  break;
        default :
                  count = 4;
                  break;
  }

  switch (mode) {

        case 0  :
                  SaveToReg (&regs.d[reg], size, operand);
                  break;
        case 1  :
                  regs.a[reg] = (u_long)operand;
                  break;
        case 2  :
                  SaveMem (regs.a[reg], size, operand);
                  break;
        case 3  :
                  SaveMem (regs.a[reg], size, operand);
                  regs.a[reg] += ((reg == 7) ? 2 : count);
                  break;
        case 4  :
                  regs.a[reg] -= ((reg == 7) ? 2 : count);
                  SaveMem (regs.a[reg], size, operand);
                  break;
        case 5  :
                  SaveMem ((long)LoadWMem (regs.pc) + regs.a[reg], size,
                           operand);
                  regs.pc += 2;
                  break;
        case 7  :
                  switch (reg) {

                        case 0  :
                                  SaveMem ((long)LoadWMem (regs.pc) & 0xffff, size, operand);
                                  regs.pc += 2;
                                  break;
                        case 1  :
                                  SaveMem ((u_long)LoadLMem (regs.pc), size, operand);
                                  regs.pc += 4;
                                  break;
                        case 2  :
                                  SaveMem (((long)LoadWMem (regs.pc)) + \
                                           regs.pc, size, operand);
                                  regs.pc +=2;
                                  break;
                        default :
                                  SayBadAddr (oper_def);
                                  break;
                  }

                  break;
                  
        default :
                  SayBadAddr (oper_def);
                  break;
  }

}


long GiveNmAddr (u_short e_addr, u_short size, OperDef *oper_def) {

  u_short       mode    = e_addr >> 3;
  u_short       reg     = e_addr & 0x0007;
  long          res;
  int           count;


  switch (size) {

        case 0  :
                  count = 1;
                  break;
        case 1  :
                  count = 2;
                  break;
        case 3  :
                  count = 4;
                  break;
        default :
                  count = 4;
                  break;
  }
  
  switch (mode) {

        case 2  :
                  return (regs.a[reg]);
                  break;
        case 3  :
                  res = regs.a[reg];
                  regs.a[reg] += ((reg == 7) ? 2 : count);
                  return (res);
                  break;
        case 4  :
                  regs.a[reg] -= ((reg == 7) ? 2 : count);
                  res = regs.a[reg];
                  return (res);
                  break;
        case 5  :
                  res = (long)LoadWMem (regs.pc) + regs.a[reg];
                  regs.pc += 2;
                  return (res);
                  break;
        case 7  :
                  switch (reg) {

                        case 0  :
                                  res = (long)LoadWMem (regs.pc) & 0xffff;
                                  regs.pc += 2;
                                  return (res);
                                  break;
                        case 2  :
                                  res = ((long)LoadWMem (regs.pc)) + regs.pc;
                                  regs.pc += 2;
                                  return (res);
                                  break;
                        case 1  :
                                  res = (u_long)LoadLMem (regs.pc);
                                  regs.pc += 4;
                                  return (res);
                                  break;
                        default :
                                  SayBadAddr (oper_def);
                                  break;
                  }
                  
        default :
                  SayBadAddr (oper_def);
                  break;
  }

  return 0;
}


char GiveCondCode (u_short cond) {

  char          pass = 0;

  switch (cond) {

        case 0  :
                  pass = 1;
                  break;
        case 1  :
                  break;
        case 2  :
                  if (!(regs.sr & 0x0005)) pass = 1;
                  break;
        case 3  :
                  if ((regs.sr & 0x0001) || (regs.sr & 0x0004)) pass = 1;
                  break;
        case 4  :
                  if (!(regs.sr & 0x0001)) pass = 1;
                  break;
        case 5  :
                  if (regs.sr & 0x0001) pass = 1;
                  break;
        case 6  :
                  if (!(regs.sr & 0x0004)) pass = 1;
                  break;
        case 7  :
                  if (regs.sr & 0x0004) pass = 1;
                  break;
        case 8  :
                  if (regs.sr & 0x0002) pass = 1;
                  break;
        case 9  :
                  if (regs.sr & 0x0002) pass = 1;
                  break;
        case 10 :
                  if (regs.sr & 0x0008) pass = 1;
                  break;
        case 11 :
                  if (regs.sr & 0x0008) pass = 1;
                  break;
        case 12 :
                  if (((regs.sr & 0x000a) == 0x000a) || \
                        (!(regs.sr & 0x000a)))
                                pass = 1;
                  break;
        case 13 :
                  if (((regs.sr & 0x000a) == 0x0008) || \
                        ((regs.sr & 0x000a) == 0x0002))
                                pass = 1;
                  break;
        case 14 :
                  if (((regs.sr & 0x000e) == 0x000a) || \
                        (!(regs.sr & 0x000e)))
                                pass = 1;
                  break;
        case 15 :
        default :
                  printf ("\nUnknown condition code.\n");
                  ExitNow ();
  }

  return (pass);
}

void SetNmFlags (long operand, u_short size) {

  signed long   ol;
  signed short  os;
  signed char   ob;
  char          pass    = 0;


  if (!operand) regs.sr |= 0x0004;

  switch (size) {

        case 0  :
                  ob = operand;
                  if (ob < 0) pass = 1;
                  break;
        case 1  :
                  os = operand;
                  if (os < 0) pass = 1;
                  break;
        case 2  :
        default :
                  ol = operand;
                  if (ol < 0) pass = 1;
                  break;
  }

  if (pass) regs.sr |= 0x0008;
}

void SetCvFlags (long dest, long src, long res, u_short size) {

  if (src > dest) regs.sr |= 0x0011;
}

void SetCvaFlags (long dest, long src, long res, u_short size) {

  if (~dest < src) regs.sr |= 0x0011;
}


/*      INSTRUCCIONES   */


void SayGoodBye (OperDef *oper_def) {

  printf ("\nCPU command not implemented: %lX %s\n", oper_def->op_called,
           oper_def->op_name);

  PrintRegsStdio ();
  DumpMem ();
  ExitNow ();
}

void SayBadAddr (OperDef *oper_def) {

  printf ("\nUnsupported effective address\n");
  SayGoodBye (oper_def);
}

char OpNotImp (OperDef *oper_def) {

  if (oper_def->debug) return 1;
  SayGoodBye (oper_def);

  return 1;
}

char OpAdd (OperDef *oper_def) {

  u_short       reg             = (oper_def->op_called >> 9) & 0x0007;
  u_short       op_mode         = (oper_def->op_called >> 6) & 0x0007;
  u_short       addr            = oper_def->op_called & 0x003f;
  long          dest;
  long          src;
  long          result;
  char          mode            = 0;


  if (reg > 7) return 0;
  if (op_mode > 6) return 0;
  if (op_mode == 3) return 0;

  if (oper_def->debug) return 1;
  regs.pc += 2;

  if (op_mode > 2) {
        mode = 1;
        op_mode -= 4;
  }

  if (!mode) {
        dest    = LoadFromReg (regs.d[reg], op_mode);
        src     = GivePtrAddr (addr, op_mode, oper_def);
  } else {
        dest    = GivePtrAddr (addr, op_mode, oper_def);
        src     = LoadFromReg (regs.d[reg], op_mode);
  }

  result        = src + dest;

  regs.sr &= 0xffe0;

  if (!mode)
        SaveToReg (&regs.d[reg], op_mode, result);
  else
        PutPtrAddr (addr, op_mode, result, oper_def);

  SetCvaFlags (dest, src, result, op_mode);
  SetNmFlags (result, op_mode);

  return 1;
}

char OpAdda (OperDef *oper_def) {

  u_short       size            = (oper_def->op_called >> 6) & 0x0007;


  if (size < 3) return 0;

  if (oper_def->debug) return 1;
  regs.pc += 2;

  if (size == 3) size = 1;
        else size = 2;

  regs.a[(oper_def->op_called >> 9) & 0x0007] += \
        GiveRealType (GivePtrAddr (oper_def->op_called & 0x003f, size,
                      oper_def), size);

  return 1;
}

char OpAddi (OperDef *oper_def) {

  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  long          to_add  = GivePtrAddr (oper_def->op_called & 0x003f, size, oper_def);
  long          dest;
  long          data    = 0;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  switch (size) {
        case 0  : data = LoadBMem (regs.pc) & 0xff; regs.pc += 2; break;
        case 1  : data = LoadWMem (regs.pc); regs.pc += 2; break;
        case 2  : data = LoadLMem (regs.pc); regs.pc += 4; break;
  }

  dest = to_add + data;

  PutPtrAddr (oper_def->op_called & 0x003f, size, dest, oper_def);

  regs.sr &= 0xffe0;

  SetCvaFlags (data, to_add, dest, size);
  SetNmFlags (dest, size);

  return 1;
}

char OpAddq (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  u_short       data    = (oper_def->op_called >> 9) & 0x0007;
  long          to_add;
  long          res;


  if (size > 2) return 0;

  if (oper_def->debug) return 1;

  regs.pc += 2;

  if (!data) data = 8;

  to_add = GivePtrAddr (addr, size, oper_def);
  res = to_add + data;

  PutPtrAddr (addr, size, res, oper_def);

  regs.sr &= 0xffe0;

  SetCvaFlags (to_add, data, res, size);
  SetNmFlags (res, size);

  return 1;
}

char OpAnd (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0007;
  u_short       reg     = (oper_def->op_called >> 9) & 0x0007;
  u_short       mode    = (size < 3) ? 1 : 0;
  long          dest;


  if ((size == 3) || (size == 7)) return 0;
  if (oper_def->debug) return 1;

  regs.pc += 2;

  if (!mode) {
        size -= 4;
        dest = GivePtrAddr (addr, size, oper_def);
        dest = LoadFromReg (regs.d[reg], size) & dest;
        PutPtrAddr (addr, size, dest, oper_def);
  } else {
        dest = LoadFromReg (regs.d[reg], size);
        dest = GivePtrAddr (addr, size, oper_def) & dest;
        SaveToReg (&regs.d[reg], size, dest);
  }

  regs.sr &= 0xfff0;

  SetNmFlags (dest, size);

  return 1;
}

char OpAndi (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  long          to_and;
  long          data;


  if (oper_def->debug) return 1;
  regs.pc += 2;
  to_and = GivePtrAddr (addr, size, oper_def);

  switch (size) {

        case 0  : data = LoadWMem (regs.pc) & 0xff;
                  regs.pc += 2;
                  break;
        case 1  : data = LoadWMem (regs.pc) & 0xffff;
                  regs.pc += 2;
                  break;
        case 2  : data = LoadLMem (regs.pc);
                  regs.pc += 4;
                  break;
  }

  to_and &= data;
  PutPtrAddr (addr, size, to_and, oper_def);

  regs.sr &= 0xfff0;
  SetNmFlags (to_and, size);

  return 1;
}

char OpBxx (OperDef *oper_def) {

  u_short       cond    = (oper_def->op_called >> 8) & 0x000f;
  long          offset  = (long)(oper_def->op_called & 0x00ff);
  u_long        ant_pc  = regs.pc;
  u_short       size    = 0;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  if (!offset) {
        offset = (long)LoadWMem (regs.pc);
        regs.pc += 2;
        size = 1;

  } else if (offset == 0xff) {
        offset = LoadLMem (regs.pc);
        regs.pc += 4;
        size = 2;
  }

  if (GiveCondCode (cond))
        regs.pc = ((ant_pc + 2) + GiveRealType (offset, size));

  return 1;
}

char OpBra (OperDef *oper_def) {

  long          offset  = (long)(oper_def->op_called & 0x00ff);
  u_long        ant_pc  = regs.pc;
  u_short       size    = 0;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  if (!offset) {
        offset = (long)LoadWMem (regs.pc);
        regs.pc += 2;
        size = 1;

  } else if (offset == 0xff) {
        offset = LoadLMem (regs.pc);
        regs.pc += 4;
        size = 2;
  }

  regs.pc = ((ant_pc + 2) + GiveRealType (offset, size));

  return 1;
}

char OpBsr (OperDef *oper_def) {        // STACK        

  long          offset  = (long)(oper_def->op_called & 0x00ff);
  u_long        ant_pc  = regs.pc;
  u_short       size    = 0;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  regs.a[7] -= 4;

  if (!offset) {
        offset = (long)LoadWMem (regs.pc);
        regs.pc += 2;
        size = 1;

  } else if (offset == 0xff) {
        offset = LoadLMem (regs.pc);
        regs.pc += 4;
        size = 2;
  }

  SaveLMem ((u_long)regs.a[7], (u_long)regs.pc);

  regs.pc = ((ant_pc + 2) + GiveRealType (offset, size));

  return 1;
}


char OpBtstd (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       src;
  char          tst;
  char          z       = 0;


  if (oper_def->debug) return 1;
  regs.pc += 2;
  src = LoadWMem (regs.pc);

  src &= 0x00ff;
  tst = GivePtrAddr (addr, 0, oper_def);

  regs.pc += 2;
  regs.sr &= 0xfffb;

  z = !(tst & (1 << src));
  if (z) regs.sr |= 0x0004;

  return 1;
}

char OpBtstr (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       src     = LoadFromReg (regs.d[(oper_def->op_called >> 9) & 0x0007], 0);
  char          tst;
  char          z       = 0;


  if (oper_def->debug) return 1;
  regs.pc += 2;
//  SaveBMem (0xa11100, 0);

  tst = GivePtrAddr (addr, 0, oper_def);

  regs.sr &= 0xfffb;

  z = !(tst & (1 << src));
  if (z) regs.sr |= 0x0004;

  return 1;
}
        
char OpChk (OperDef *oper_def) {

  u_short       op      = oper_def->op_called;
  u_short       size    = (op >> 7) & 0x0003;


  if ((size != 2) && (size != 3)) return 0;

  if (oper_def->debug) return 1;

  SayGoodBye (oper_def);
  return 1;
}

char OpClr (OperDef *oper_def) {

  if (oper_def->debug) return 1;
  regs.pc += 2;

  PutPtrAddr (oper_def->op_called & 0x003f,
             (oper_def->op_called >> 6) & 0x0003,
             0, oper_def);

  regs.sr &= 0xfff4;
  regs.sr |= 0x0004;

  return 1;
}

char OpClrs (OperDef *oper_def) {

  if (oper_def->debug) return 1;
  regs.pc += 2;

  regs.a[7] = 0xfffe00;

  return 1;
}

char OpCmp (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0007;
  u_short       reg     = (oper_def->op_called >> 9) & 0x0007;
  u_short       mode    = (size > 2) ? 1 : 0;
  long          dest;
  long          to_sub;
  long          res;


  if (size > 4 && size < 7) return 0;
  if (oper_def->debug) return 1;

  if (mode) {
        if (size == 3) size = 1;
                else if (size == 7) size = 2;
  }

  regs.pc += 2;

  dest = LoadFromReg ((mode) ? regs.a[reg] : regs.d[reg], size);

  to_sub = GivePtrAddr (addr, size, oper_def);
  res = dest - GiveRealType (to_sub, size);

  regs.sr &= 0xfff0;

  SetCvFlags (dest, to_sub, res, size);
  SetNmFlags (res, size);

  return 1;
}

char OpCmpm (OperDef *oper_def) {

  u_short       src     = oper_def->op_called & 0x0007;
  u_short       dest    = (oper_def->op_called >> 9) & 0x0007;
  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  long          dest_v  = LoadMem (regs.a[dest], size);
  long          src_v   = LoadMem (regs.a[src], size);
  long          res     = dest_v - src_v;
  u_short       count   = size*2;


  if (size > 2) return 0;

  if (oper_def->debug) return 1;

  if (!count) count = 1;

  regs.pc += 2;
  regs.a[dest] += count;
  regs.a[src] += count;

  regs.sr &= 0xfff0;

  SetCvFlags (dest_v, src_v, res, size);
  SetNmFlags (dest_v, size);

  return 1;
}

char OpDbxx (OperDef *oper_def) {

  u_short       cond    = (oper_def->op_called >> 8) & 0x000f;
  u_short       reg     = oper_def->op_called & 0x0007;
  short         offset;
  short         to_dec;


  if (oper_def->debug) return 1;
  regs.pc += 2;
  offset = (short)LoadWMem (regs.pc);
  regs.pc += 2;

  if (GiveCondCode (cond)) return 1;

  to_dec = LoadFromReg (regs.d[reg], 1);
  to_dec--;
  SaveToReg (&regs.d[reg], 1, to_dec);

  if (to_dec != -1) {
        regs.pc -= 2;
        regs.pc = (regs.pc + offset);
  }

  return 1;
}

char OpEor (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0007;
  u_short       reg     = (oper_def->op_called >> 9) & 0x0007;
  long          dest;


  if ((size < 4) || (size > 6)) return 0;
  if (oper_def->debug) return 1;

  regs.pc += 2;
  size -= 4;

  dest = GivePtrAddr (addr, size, oper_def);
  dest ^= LoadFromReg (regs.d[reg], size);
  PutPtrAddr (addr, size, dest, oper_def);

  regs.sr &= 0xfff0;

  SetNmFlags (dest, size);

  return 1;
}

char OpJmp (OperDef *oper_def) {

  u_long        to_jmp;

  if (oper_def->debug) return 1;
  regs.pc += 2;

  to_jmp = (u_long)GiveNmAddr (oper_def->op_called & 0x003f, 2, oper_def);

  regs.pc = to_jmp;

  return 1;
}

char OpJsr (OperDef *oper_def) {        // STACK

  u_long        to_jmp;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  regs.a[7] -= 4;
  SaveLMem (regs.a[7], (u_long)regs.pc);

  to_jmp = (u_long)GiveNmAddr (oper_def->op_called & 0x003f, 2, oper_def);

  regs.pc = to_jmp;

  return 1;
}

char OpLea (OperDef *oper_def) {

  u_short       reg     = (oper_def->op_called >> 9) & 0x0007;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  regs.a[reg] = (u_long)GiveNmAddr (oper_def->op_called & 0x003f, 2, oper_def);

  return 1;
}

char OpLink (OperDef *oper_def) {       //STACK

  u_short       reg     = oper_def->op_called & 0x0007;
  short         offset;


  if (oper_def->debug) return 1;

  regs.pc += 2;

  offset = (short)LoadWMem (regs.pc);
  regs.pc += 2;

  regs.a[7] -= 4;
  SaveLMem (regs.a[7], regs.a[reg]);

  regs.a[reg] = regs.a[7];
  regs.a[7] += offset;

  return 1;
}

char OpLslr (OperDef *oper_def) {               // FLAGS

  u_short       size            = (oper_def->op_called >> 6) & 0x0003;
  u_short       cnt             = (oper_def->op_called >> 9) & 0x0007;
  u_short       reg             = oper_def->op_called & 0x0007;
  u_short       mode            = (oper_def->op_called >> 5) & 0x0001;
  long          to_shift;


  if (oper_def->debug) return 1;


  regs.pc += 2;

  to_shift = LoadFromReg (regs.d[reg], size);

  if (!mode) {
        if (!cnt) cnt = 8;
  } else {
        cnt = (regs.d[cnt] % 64);
  }

  to_shift <<= cnt;

  SaveToReg (&regs.d[reg], size, to_shift);
  SetNmFlags (to_shift, size);

  return 1;
}

char OpMove (OperDef *oper_def) {

  u_short       src_addr        = oper_def->op_called & 0x003f;
  u_short       dest_addr_tmp   = (oper_def->op_called >> 6) & 0x003f;
  u_short       size            = (oper_def->op_called >> 12) & 0x0003;
  u_short       dest_addr       = ((dest_addr_tmp >> 3) | ((dest_addr_tmp << 3) & 0x003f));
  long          to_move;


  if (!size) return 0;
  if (size > 3) return 0;

  if (oper_def->debug) return 1;

  switch (size) {

        case 1  : size = 0; break;
        case 2  : break;
        case 3  : size = 1; break;
  }

  regs.pc += 2;
  regs.sr &= 0xfff0;

  to_move = GivePtrAddr (src_addr, size, oper_def);
  PutPtrAddr (dest_addr, size, to_move, oper_def);

  SetNmFlags (to_move, size);

  return 1;
}

char OpMovea (OperDef *oper_def) {

  u_short       size    = (oper_def->op_called >> 12) & 0x0007;


  if (size < 2) return 0;

  if (oper_def->debug) return 1;
  regs.pc += 2;
  if (size == 3) size = 1;

  SaveToReg (&regs.a[(oper_def->op_called >> 9) & 0x0007], size,
             oper_def->op_called & 0x003f);

  return 1;
}

char OpMovem (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       mode    = (oper_def->op_called >> 10) & 0x0001;
  u_short       size    = (oper_def->op_called >> 6) & 0x0001;
  u_short       mask;
  u_short       dmask;
  u_short       amask;
  u_short       d_cnt   = 0;
  u_short       a_cnt   = 0;


  if (oper_def->debug) return 1;

  size++;
  regs.pc += 2;

  mask = LoadWMem (regs.pc);
  regs.pc += 2;

  if (mode) {
        amask = (mask >> 8) & 0x00ff;
        dmask = mask & 0x00ff;

        while (dmask) {
                if (dmask & 1) {
                        regs.d[d_cnt] = (u_long)GivePtrAddr (addr, size, oper_def);
                }
                d_cnt++;
                dmask >>= 1;
        }

        while (amask) {
                if (amask & 1) {
                        regs.a[a_cnt] = (u_long)GivePtrAddr (addr, size, oper_def);
                }
                a_cnt++;
                amask >>= 1;
        }

        return 1;

  } else {

        a_cnt = 7;
        d_cnt = 7;
        amask = mask & 0x00ff;
        dmask = (mask >> 8) & 0x00ff;

        while (amask) {
                if (amask & 1) {
                        PutPtrAddr (addr, size, regs.a[a_cnt], oper_def);
                }
                a_cnt--;
                amask >>= 1;
        }

        while (dmask) {
                if (dmask & 1) {
                        PutPtrAddr (addr, size, regs.d[d_cnt], oper_def);
                }
                d_cnt--;
                dmask >>= 1;
        }

        return 1;
  }

  return 1;
}

char OpMoveq (OperDef *oper_def) {

  u_short       reg     = (oper_def->op_called >> 9) & 0x0007;
  u_short       data    = oper_def->op_called & 0x00ff;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  regs.d[reg] = (long)data;

  return 1;
}
                
char OpMovetccr (OperDef *oper_def) {

  u_short       new_ccr;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  new_ccr = (u_short)GivePtrAddr (oper_def->op_called & 0x003f, 1, oper_def);

  regs.sr = new_ccr;

  return 1;
}

char OpMovefsr (OperDef *oper_def) {

  if (oper_def->debug) return 1;
  regs.pc += 2;

  PutPtrAddr (oper_def->op_called & 0x003f, 1, regs.sr, oper_def);

  return 1;
}

char OpMovetsr (OperDef *oper_def) {

  u_short       new_ccr;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  new_ccr = (u_short)GivePtrAddr (oper_def->op_called & 0x003f, 1, oper_def);

  new_ccr &= 0x00ff;
  regs.sr &= 0xff00;

  regs.sr |= new_ccr;

  return 1;
}

char OpMoveusp (OperDef *oper_def) {

  u_short       reg     = oper_def->op_called & 0x0007;
  u_short       mode    = (oper_def->op_called >> 3) & 0x0001;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  if (!mode)
        regs.usp = regs.a[reg];
  else
        regs.a[reg] = regs.usp;

  return 1;
}

char OpNegx (OperDef *oper_def) {               //BUG

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  long          src;
  long          dest;


  if (oper_def->debug) return 1;

  regs.pc += 2;

  src = GivePtrAddr (addr, size, oper_def);
  dest = 0 - src - ((regs.sr & 0x0010) ? 1 : 0);

  PutPtrAddr (addr, size, dest, oper_def);

  SetNmFlags (dest, size);
  SetCvFlags (0, src, dest, size);

  return 1;
}

char OpNop (OperDef *oper_def) {

  if (oper_def->debug) return 1;
  regs.pc += 2;

  return 1;
}

char OpNot (OperDef *oper_def) {

  u_short       addr            = oper_def->op_called & 0x003f;
  u_short       size            = (oper_def->op_called >> 6) & 0x0003;
  long          to_not;


  if (oper_def->debug) return 1;
  regs.pc += 2;

  to_not = GivePtrAddr (addr, size, oper_def);

  to_not = ~to_not;

  regs.sr &= 0xfff0;
  SetNmFlags (to_not, size);

  PutPtrAddr (addr, size, to_not, oper_def);

  return 1;
}

char OpOr (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0007;
  u_short       reg     = (oper_def->op_called >> 9) & 0x0007;
  u_short       mode    = (size < 3) ? 1 : 0;
  long          dest;


  if ((size == 3) || (size == 7)) return 0;
  if (oper_def->debug) return 1;

  regs.pc += 2;

  if (!mode) {
        size -= 4;
        dest = GivePtrAddr (addr, size, oper_def);
        dest = LoadFromReg (regs.d[reg], size) | dest;
        PutPtrAddr (addr, size, dest, oper_def);
  } else {
        dest = LoadFromReg (regs.d[reg], size);
        dest = GivePtrAddr (addr, size, oper_def) | dest;
        SaveToReg (&regs.d[reg], size, dest);
  }

  regs.sr &= 0xfff0;

  SetNmFlags (dest, size);

  return 1;
}

char OpOri (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  long          to_or;
  long          data;


  if (size > 2) return 0;
  if (addr == 0x3c) return 0;

  if (oper_def->debug) return 1;

  regs.pc += 2;
  to_or = GivePtrAddr (addr, size, oper_def);

  switch (size) {

        case 0  : data = LoadWMem (regs.pc) & 0xff;
                  regs.pc += 2;
                  break;
        case 1  : data = LoadWMem (regs.pc) & 0xffff;
                  regs.pc += 2;
                  break;
        case 2  : data = LoadLMem (regs.pc);
                  regs.pc += 4;
                  break;
  }

  to_or |= data;
  PutPtrAddr (addr, size, to_or, oper_def);

  regs.sr &= 0xfff0;
  SetNmFlags (to_or, size);

  return 1;
}

char OpOritccr (OperDef *oper_def) {

  u_short       data;


  if (oper_def->debug) return 1;

  regs.pc += 2;

  data = LoadWMem (regs.pc) & 0xff;
  regs.pc += 2;

  regs.sr |= (char)data;

  return 1;
}

char OpRts (OperDef *oper_def) {        // STACK

  u_long        new_pc;


  if (oper_def->debug) return 1;

  new_pc = (u_long)LoadLMem ((u_long)regs.a[7]);

  regs.a[7] += 4;
  regs.pc = new_pc;

  return 1;
}

char OpSxx (OperDef *oper_def) {

  u_short       cond    = (oper_def->op_called >> 8) & 0x000f;

  if (oper_def->debug) return 1;
  regs.pc += 2;

  PutPtrAddr (oper_def->op_called & 0x003f, 0,
              (GiveCondCode (cond)) ? 0xff : 0, oper_def);

  return 1;
}

char OpSub (OperDef *oper_def) {        // FLAGS

  u_short       reg             = (oper_def->op_called >> 9) & 0x0007;
  u_short       op_mode         = (oper_def->op_called >> 6) & 0x0007;
  u_short       addr            = oper_def->op_called & 0x003f;
  long          dest;
  long          src;
  long          result;
  char          mode            = 0;


  if (reg > 7) return 0;
  if (op_mode > 6) return 0;

  if (oper_def->debug) return 1;

  regs.pc += 2;

  if (op_mode > 2) {
        mode = 1;
        op_mode -= 4;
  }

  if (!mode) {
        dest    = LoadFromReg (regs.d[reg], op_mode);
        src     = GivePtrAddr (addr, op_mode, oper_def);
  } else {
        dest    = GivePtrAddr (addr, op_mode, oper_def);
        src     = LoadFromReg (regs.d[reg], op_mode);
  }

  result        = dest - src;

  regs.sr &= 0xffe0;

  if (!mode)
        SaveToReg (&regs.d[reg], op_mode, result);
  else
        PutPtrAddr (addr, op_mode, result, oper_def);

  SetCvFlags (dest, src, result, op_mode);
  SetNmFlags (result, op_mode);

  return 1;
}

char OpSubq (OperDef *oper_def) {

  u_short       addr    = oper_def->op_called & 0x003f;
  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  u_short       data    = (oper_def->op_called >> 9) & 0x0007;
  long          to_sub;


  if (size > 2) return 0;

  if (oper_def->debug) return 1;

  regs.pc += 2;

  if (!data) data = 8;

  to_sub = GivePtrAddr (addr, size, oper_def);
  to_sub -= data;

  PutPtrAddr (addr, size, to_sub, oper_def);

  regs.sr &= 0xffe0;

  SetCvFlags (to_sub+data, data, to_sub, size);
  SetNmFlags (to_sub, size);

  return 1;
}

char OpSubx (OperDef *oper_def) {       // FLAGS

  u_short       size    = (oper_def->op_called >> 6) & 0x0003;
  u_short       mode    = (oper_def->op_called >> 3) & 0x0001;
  u_short       dest    = (oper_def->op_called >> 9) & 0x0007;
  u_short       src     = oper_def->op_called & 0x0007;
  u_short       count   = size*2;
  long          v_dest;
  long          v_src;
  long          res;


  if (size > 2) return 0;

  if (oper_def->debug) return 1;

  regs.pc += 2;

  if (!count) count = 1;
  if (!mode) {
        v_dest = LoadFromReg (regs.d[dest], size);
        v_src = LoadFromReg (regs.d[src], size);
  } else {
        regs.a[dest] -= count;
        regs.a[src] -= count;
        v_dest = LoadMem (regs.a[dest], size);
        v_src = LoadMem (regs.a[src], size);
  }

  res = GiveRealType (v_dest, size) - GiveRealType (v_src, size);

  regs.sr &= 0xffe0;

  if (!mode)
        SaveToReg (&regs.d[dest], size, res);
  else
        SaveMem (regs.a[dest], size, res);

  SetCvFlags (v_dest, v_src, res, size);
  SetNmFlags (res, size);

  return 1;
}

char OpTst (OperDef *oper_def) {

  u_short       op      = oper_def->op_called;
  u_short       addr    = op & 0x003f;
  u_short       size    = (op >> 6) & 0x0003;
  long          to_tst;


  if (oper_def->debug) return 1;

  regs.pc += 2;
  to_tst   = GivePtrAddr (addr, size, oper_def);

  regs.sr &= 0xfff0;

  SetNmFlags (to_tst, size);

  return 1;
}

char OpUnlk (OperDef *oper_def) {       //STACK

  u_short       reg     = oper_def->op_called & 0x0007;


  if (oper_def->debug) return 1;

  regs.pc += 2;

  regs.a[7] = regs.a[reg];
  regs.a[reg] = (u_long)LoadLMem (regs.a[7]);

  regs.a[7] += 4;

  return 1;
}


        
