/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#ifndef __M68K_INCLUDED__
#define __M68K_INCLUDED__


#include <stdlib.h>
#include "m68misc.h"
#include "vdp.h"
#include "genio.h"

#define __inline__


extern void Execute_CPU (void);
extern void Executen_CPU (unsigned long cnt);
extern void RunGenesis (void);
void ExecutenB_CPU (unsigned long cnt);


#define BYTE signed char
#define UBYTE unsigned char
#define UWORD unsigned short
#define WORD short
#define ULONG unsigned int
#define LONG int
#define CPTR unsigned int



//extern void inline Exception(int nr, CPTR oldpc);

typedef void cpuop_func(void);
extern cpuop_func *cpufunctbl[65536];
extern void *functbl_ptr;
extern ULONG ExtOpCode;
extern void *regs_ptr;
extern void *flags_ptr;

typedef char flagtype;

LONG wat_readmeml(void *a);
#pragma aux wat_readmeml=\
       "mov eax,[esi]"\
       "bswap eax    "\
       parm [esi] \
       value [eax];
#define READ_MEML(a,b) b=wat_readmeml(a)

WORD wat_readmemw(void *a);
#pragma aux wat_readmemw=\
       "mov ax,[esi]"\
       "xchg al,ah    "\
       parm [esi] \
       value [ax];
#define READ_MEMW(a,b) b=wat_readmemw(a)


extern unsigned char *RAM;

/*#define get_byte(a) LoadBMem(a)
#define get_word(a) LoadWMem(a)
#define get_long(a) LoadLMem(a)
#define put_byte(a,b) SaveBMem(a,b)
#define put_word(a,b) SaveWMem(a,b)
#define put_long(a,b) SaveLMem(a,b)*/


union flagu {
    struct {
        char v;
        char c;
        char n;
        char z;
    } flags;
    ULONG longflags;
};

extern int areg_byteinc[];
extern int movem_index1[256];
extern int movem_index2[256];
extern int movem_next[256];
extern int imm8_table[];
extern UBYTE *actadr;

typedef struct
{
            ULONG d[8];
            CPTR  a[8],usp,isp,msp;
            UWORD sr;
            flagtype t1;
            flagtype t0;
            flagtype s;
            flagtype m;
            flagtype x;
            flagtype stopped;
            int intmask;
            ULONG pc;

            union flagu regflags;

            ULONG vbr,sfc,dfc;
            double fp[8];
            ULONG fpcr,fpsr,fpiar;
} regstruct;

extern regstruct regs, lastint_regs;

extern union flagu intel_flag_lookup[256];
//extern union flagu regflags;

#define ZFLG (regs.regflags.flags.z)
#define NFLG (regs.regflags.flags.n)
#define CFLG (regs.regflags.flags.c)
#define VFLG (regs.regflags.flags.v)


static __inline__ UWORD nextiword(void)
{
    unsigned int i=regs.pc&0xffffff;
    regs.pc+=2;
    if (regs.pc < 0x3fffff) return ( (RAM[i]<<8) | RAM[i+1] );
        else return (LoadWMem (i));
}

static __inline__ ULONG nextilong(void)
{
    unsigned int i=regs.pc&0xffffff;
    regs.pc+=4;
    if (regs.pc < 0x3fffff)
        return ( (RAM[i]<<24) | (RAM[i+1]<<16) | (RAM[i+2]<<8) | RAM[i+3] );
    else
        return (LoadLMem (i));
}

static __inline__ void m68k_setpc(CPTR newpc)
{
    regs.pc = newpc;
}

static __inline__ CPTR m68k_getpc(void)
{
    return regs.pc;
}

static __inline__ ULONG get_disp_ea (ULONG base)
{
   UWORD dp = nextiword();
        int reg = (dp >> 12) & 7;
        LONG regd = dp & 0x8000 ? regs.a[reg] : regs.d[reg];
        if ((dp & 0x800) == 0)
            regd = (LONG)(WORD)regd;
        return base + (BYTE)(dp) + regd;
}

static __inline__ int cctrue(const int cc)
{
            switch(cc){
              case 0: return 1;                       /* T */
              case 1: return 0;                       /* F */
              case 2: return !CFLG && !ZFLG;          /* HI */
              case 3: return CFLG || ZFLG;            /* LS */
              case 4: return !CFLG;                   /* CC */
              case 5: return CFLG;                    /* CS */
              case 6: return !ZFLG;                   /* NE */
              case 7: return ZFLG;                    /* EQ */
              case 8: return !VFLG;                   /* VC */
              case 9: return VFLG;                    /* VS */
              case 10:return !NFLG;                   /* PL */
              case 11:return NFLG;                    /* MI */
              case 12:return NFLG == VFLG;            /* GE */
              case 13:return NFLG != VFLG;            /* LT */
              case 14:return !ZFLG && (NFLG == VFLG); /* GT */
              case 15:return ZFLG || (NFLG != VFLG);  /* LE */
             }
             abort();
             return 0;
}

static __inline__ void MakeSR(void)
{
    regs.sr = ((regs.t1 << 15) | (regs.t0 << 14)
      | (regs.s << 13) | (regs.m << 12) | (regs.intmask << 8)
      | (regs.x << 4) | (NFLG << 3) | (ZFLG << 2) | (VFLG << 1)
      |  CFLG);
}

static __inline__ void MakeFromSR(void)
{
  /*  int oldm = regs.m; */
    int olds = regs.s;

    regs.t1 = (regs.sr >> 15) & 1;
    regs.t0 = (regs.sr >> 14) & 1;
    regs.s = (regs.sr >> 13) & 1;
    regs.m = (regs.sr >> 12) & 1;
    regs.intmask = (regs.sr >> 8) & 7;
    regs.x = (regs.sr >> 4) & 1;
    NFLG = (regs.sr >> 3) & 1;
    ZFLG = (regs.sr >> 2) & 1;
    VFLG = (regs.sr >> 1) & 1;
    CFLG = regs.sr & 1;

    if (olds != regs.s) {
       if (olds) {
         regs.isp = regs.a[7];
         regs.a[7] = regs.usp;
        } else {
           regs.usp = regs.a[7];
           regs.a[7] = regs.isp;
        }
     }

}

long LoadLFMem (void *a);
#pragma aux LoadLFMem=\
        "mov eax,[esi]"\
        "bswap eax    "\
        parm [esi] \
        value [eax];


long RorLong (u_long target);
#pragma aux RorLong=\
        "bswap eax    "\
        parm [eax] \
        value [eax];

short RorShort (u_short target);
#pragma aux RorShort=\
        "xchg al,ah   "\
        parm [ax] \
        value [ax];


int RunCPU (void);
void Init68000 (long IPeriod);


static long get_long (u_long pos) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        return (RorLong ((*(u_long *)tmp)));
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        return (RorLong ((*(u_long *)tmp)));
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        return ((long)ReadIOPort (pos, 2));
  }

  if (pos >= 0xc00000 && pos <= 0xc00fff) {

        return ((long)ReadVDPPort (pos, 2));
  }

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        return (RorLong ((*(u_long *)tmp)));
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        return (RorLong ((*(u_long *)tmp)));
  }

  ErrorMem (pos);
  return 0;
}

static short get_word (u_long pos) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        return (RorShort ((*(u_short *)tmp)));
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        return (RorShort ((*(u_short *)tmp)));
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        return ((short)ReadIOPort (pos, 1));      
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        return ((short)ReadVDPPort (pos, 1));
  }

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        return (RorShort ((*(u_short *)tmp)));
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        return (RorShort ((*(u_short *)tmp)));
  }

  ErrorMem (pos);
  return 0;
}

/*void get_byte (u_long pos);

#pragma aux get_byte=\
"and eax, 0ffffffh"\
"push edi"\
"cmp eax, 3fffffh"\
"jg short lb_no_rom"\
"mov edi, [rom_ptr]"\
"mov al, byte ptr[edi+eax]"\
"pop edi"\
"jmp short lb_done"\
"lb_no_rom:"\
"cmp eax, 0ff0000h"\
"jl short lb_no_ram"\
"sub eax, 0ff0000h"\
"mov edi, [ram_ptr]"\
"mov al, byte ptr [edi+eax]"\
"pop edi"\
"jmp short lb_done"\
"lb_no_ram:"\
"cmp eax, 0c00000h"\
"jl short lb_no_vdp"\
"push 0"\
"push eax"\
"call ReadVDPPort"\
"add esp, 8"\
"pop edi"\
"jmp short lb_done"\
"lb_no_vdp:"\
"cmp eax, 0a04000h"\
"jl short lb_no_io"\
"push 0"\
"push eax"\
"call ReadIOPort"\
"add esp, 8"\
"pop edi"\
"jmp short lb_done"\
"lb_no_io:"\
"cmp eax, 0a00000h"\
"jl short lb_error_mem"\
"sub eax, 0a00000h"\
"mov edi, [z80ram_ptr]"\
"mov al, byte ptr [edi+eax]"\
"pop edi"\
"jmp short lb_done"\
"lb_error_mem:"\
"push eax"\
"call ErrorMem"\
"add esp, 8"\
"pop edi"\
"lb_done:"\
 parm [eax] \
 value [eax];*/



static char get_byte (u_long pos) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        return (*tmp);
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        return (*tmp);
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        return ((char)ReadIOPort (pos, 0));
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        return ((char)ReadVDPPort (pos, 0));
  }

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        return (*tmp);
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        return (*tmp);
  }

  ErrorMem (pos);
  return 0;
}

static void put_long (u_long pos, long to_save) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        WriteIOPort (pos, 2, to_save);
        return;
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        WriteVDPPort (pos, 2, to_save);
        return;
  }

  //vdp_write = 1;

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  ErrorMem (pos);
}

static void put_word (u_long pos, short to_save) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        (*(short *)tmp) = RorShort (to_save);
        return;
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        (*(short *)tmp) = RorShort (to_save);
        return;
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        WriteIOPort (pos, 1, to_save);
        return;
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        WriteVDPPort (pos, 1, to_save);
        return;
  }

  //vdp_write = 1;

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        (*(short *)tmp) = RorShort (to_save);
        return;
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        (*(short *)tmp) = RorShort (to_save);
        return;
  }


  ErrorMem (pos);
}

static void put_byte (u_long pos, char to_save) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        *tmp = to_save;
        return;
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        *tmp = to_save;
        return;
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        WriteIOPort (pos, 0, to_save);
        return;
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        WriteVDPPort (pos, 0, to_save);
        return;
  }

  //vdp_write = 1;

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        *tmp = to_save;
        return;
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        *tmp = to_save;
        return;
  }

  ErrorMem (pos);
}



#endif
