/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/



#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <i86.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "sizedefs.h"
#include "misc.h"
#include "vesa20.h"
#include "sound.h"



volatile struct _snd_ snd;


void (interrupt far *SBIrqOld)();
void interrupt SBIrqHandler(void);


int page_regs[] = { 0x87, 0x83, 0x81, 0x82, -1, 0x8b, 0x89, 0x8a };
int base_regs[] = { 0, 2, 4, 6 };
int count_regs[] = { 1, 3, 5, 7 };



static long ReadDSP (void) {

  u_long        cnt;

  for (cnt = 0; cnt < 100000; cnt++) {
        if (inp (snd.sb_port+0x0e) & 0x80)
                return (inp (snd.sb_port+0x0a));
  }

  return -1;
}

static u_long WriteDSP (long to_write) {

  u_long        cnt;

  for (cnt = 0; cnt < 100000; cnt++) {
        if (!(inp (snd.sb_port+0x0c) & 0x80)) {
                outp (snd.sb_port+0x0c, to_write);
                return 1;
        }
  }

  return 0;
}

u_long InitSB (u_long snd_rate) {

  char         *ptr;
  long          cnt;


  memset (&snd, 0, sizeof (struct _snd_));

  snd.sb_port           = 0x220;
  snd.sb_irq            = 5;
  snd.sb_dma            = 1;
  snd.sound_enable      = 0;

  snd.max_freq          = snd_rate/2;
  snd.noise_gen         = 1;
  snd.master_volume     = 192;

  for (cnt = 0; cnt < SND_CHANNELS; cnt++)
        snd.chan_type[cnt] = SND_MELODIC;

  SBIrqOld              = NULL;

  if (ptr = getenv ("BLASTER"))
        while (*ptr)
                switch (toupper(*ptr++)) {
                        case 'A': snd.sb_port = strtol (ptr, 0, 16);
                                  break;
                        case 'D': snd.sb_dma = strtol (ptr, 0, 16);
                                  break;
                        case 'I': snd.sb_irq = strtol (ptr, 0, 16);
                                  break;
                }

  if ((snd.sb_irq) > 7 || (snd.sb_dma > 3)) return 0;

  outp (snd.sb_port+0x06, 0x01);
  for (cnt = 0; cnt < 6; cnt++) inp (snd.sb_port+0x06);
  outp (snd.sb_port+0x06, 0x00);

  for (cnt = 0; cnt < 100; cnt++) {
        if (inp (snd.sb_port + 0xa) == 0xaa) break;
  }

  if (cnt == 100) return 0;

  SBIrqOld = (void (interrupt *)()) getvect (snd.sb_irq+8);
  setvect (snd.sb_irq+8, SBIrqHandler);
  outp (0x21, inp (0x21) & ~(1 << snd.sb_irq));

  cnt = SND_BUFSIZE+2;

  if (pm_getmemdos ((u_long)cnt, &snd.mem_dos)) return 0;

  snd.buffer = (u_char *)(snd.mem_dos.linear);
  cnt = (snd.mem_dos.linear);

  snd.buf_addr = cnt;

  /*if ((cnt >> 16) != ((cnt+2 * SND_BUFSIZE) >> 16))
        snd.buffer += (2*SND_BUFSIZE);*/

  memset (snd.buffer, 0, SND_BUFSIZE);
  snd.snd_rate = snd_rate;

  WriteDSP (0x40);
  WriteDSP ((65536L - (256000000L/snd_rate)) / 256);
  _disable ();
  outp (0x0a, snd.sb_dma | 0x04);
  outp (0x0c, 0x00);
  outp (0x0b, snd.sb_dma | 0x58);

  cnt = (snd.sb_dma * 2);
  outp (cnt, (int)snd.buffer & 0xff);
  outp (cnt, ((int)snd.buffer >> 8) & 0xff);
  //outp (cnt, ((int)snd.buffer >> 16) & 0xff);

  cnt++;
  outp (cnt, (SND_BUFSIZE-1) & 0xff);
  outp (cnt, (SND_BUFSIZE-1) >> 8);
  outp (page_regs[snd.sb_dma], ((int)snd.buffer >> 16) & 0xff);
  outp (0x0a, snd.sb_dma);

  _enable ();
  WriteDSP (0xd1);
  WriteDSP (0x48);
  WriteDSP ((SND_BUFSIZE-1) & 0xff);
  WriteDSP ((SND_BUFSIZE-1) >> 8);
  WriteDSP (0x90);

  snd.cur_buffer = 0;
  snd.sound_enable = 1;

  return 1;
}

void ShutDownSB (void) {

  if (!snd.sound_enable) return;

  WriteDSP (0xd3);
  WriteDSP (0xd0);

  outp (0x0a, snd.sb_dma | 0x04);
  outp (0x21, inp (0x21) | (1 << snd.sb_irq));

  if (SBIrqOld) {
        setvect (snd.sb_irq+8, SBIrqOld);
        SBIrqOld = NULL;
  }

  pm_freememdos (&snd.mem_dos);
}

void _loadds interrupt far SBIrqHandler(void) {
#pragma aux SbIrqHandler modify [EAX EBX ECX EDX ESI EDI]

  u_char       *ptr;
  u_long        buf_addr        = snd.buf_addr;
  long          I,J,K,L1,L2,V;
  int           cnt;


  /*for(J = 0; J < SND_CHANNELS; J++)
   if(snd.chan_freq[J] && (V=snd.chan_volume[J]) && \
     (snd.master_switch & (1<<J)))

        switch(snd.chan_type[J]) {

                case SND_MELODIC:
                                  K=0x10000*snd.chan_freq[J]/snd.snd_rate;
                                  L1 = snd.count[J];

                                  for(I = 0; I < SND_BUFSIZE; I++) {
                                        L2 = L1 + K;
                                        snd.wave[I] += \
                                        V*(L1&0x8000? (L2&0x8000? 32767:0): \
                                        (L2&0x8000? 0:-32767));
                                        L1 = L2;
                                  }
                                  snd.count[J] = L1;
                                  break;

                case SND_NOISE:
                                  K=0x10000*snd.chan_freq[J] / snd.snd_rate;
                                  L1 = snd.count[J];
                                  for(I = 0; I < SND_BUFSIZE; I++) {
                                        L1 += K;
                                        if (L1 & 0xFFFF0000) {
                                                L1 &= 0xFFFF;
                                                if ((snd.noise_gen <<= 1) & 0x80000000)
                                                        snd.noise_gen^=0x00040001;
                                        }
                                        snd.wave[I] += V*(snd.noise_gen & 1 ? \
                                                        32767:-32767);
                                  }
                                  snd.count[J] = L1;
                                  break;
        }*/

  /*ptr = snd.buffer + (snd.cur_buffer * SND_BUFSIZE);
  snd.cur_buffer^=1;

  for(J = 0; J < SND_BUFSIZE; J++) {
        *ptr++ = (snd.wave[J] / SND_CHANNELS) * snd.master_volume/256/256/256+128;
        snd.wave[J] = 0;
  }*/

  /*ptr = snd.buffer + (snd.cur_buffer * SND_BUFSIZE);
  snd.buf_empty[snd.cur_buffer] = 1;
  snd.cur_buffer ^= 1;
  if (snd.buf_empty[snd.cur_buffer]) snd.buf_overlap = 1;

  buf_addr += (snd.cur_buffer) ? SND_BUFSIZE : 0;

  outp (0xa, snd.sb_dma + 4);
  outp (0xc, snd.sb_dma);
  outp (0xb, snd.sb_dma + 0x48);

  outp (base_regs[snd.sb_dma], buf_addr & 0xff);
  outp (base_regs[snd.sb_dma], (buf_addr >> 8) & 0xff);

  outp (count_regs[snd.sb_dma], (SND_BUFSIZE-1) & 0xff);
  outp (count_regs[snd.sb_dma], ((SND_BUFSIZE-1) >> 8) & 0xff);

  outp (0xa, snd.sb_dma);
  WriteDSP (0x14);

  WriteDSP ((SND_BUFSIZE-1) & 0xff);
  WriteDSP (((SND_BUFSIZE-1) >> 8) & 0xff);*/

  ptr = snd.buffer;

  for (cnt = 0; cnt < SND_BUFSIZE; cnt++) {
        *ptr++ = snd.wave[cnt+(snd.cur_buffer*SND_BUFSIZE)] * snd.master_volume / 256;
        snd.wave[cnt+(snd.cur_buffer*SND_BUFSIZE)] = 0;
  }

  if (++snd.cur_buffer == SND_NBUFS) snd.cur_buffer = 0;

  inp (snd.sb_port+0x0E);
  outp (0x20, 0x20);
}

