/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#ifndef __VDP_INCLUDED__
#define __VDP_INCLUDED__

#include "sizedefs.h"
#include "st0rm.h"


struct _vdp_sr_ {

        //u_short                 vdpsr;

        u_short                 pal             : 1;
        u_short                 dma_busy        : 1;
        u_short                 horz_blk        : 1;
        u_short                 vert_blk        : 1;
        u_short                 odd_frame       : 1;
        u_short                 spr_coll        : 1;
        u_short                 spr_ovflow      : 1;
        u_short                 vert_intr       : 1;
        u_short                 fifo_full       : 1;
        u_short                 fifo_empt       : 1;
        u_short                 dummy           : 6;

};

struct _vdp_ {

        u_long                  vert_intr;
        u_long                  horz_intr;

        u_char                  vi_enable;
        u_char                  hi_enable;
        u_char                  ei_enable;
        u_char                  display;
        u_char                  dma_enable;
        u_char                  pal_effect;
        u_short                 hv_cnt;

        struct _vdp_sr_         vdp_sr;
        u_long                  reg[25];
        u_long                  id_code;
        u_long                  dest_addr;
        u_long                  run;

        u_long                  base_scrl_a;
        u_long                  base_scrl_b;
        u_long                  base_scrl_h;
        u_long                  base_win;
        u_long                  base_spr;

        u_long                  scrl_size_v;
        u_long                  scrl_size_h;
        u_long                  scrl_mode_v;
        u_long                  scrl_mode_h;

        u_long                  win_h_pos;
        u_long                  win_v_pos;

        u_long                  cell_mode;
        u_long                  h_cells;
        u_long                  v_cells;
        u_long                  vid_mode;
        u_long                  back_color;

        u_long                  dma_addr;
        u_long                  dma_mode;
        u_long                  dma_cnt;
        u_long                  dma_fdata;

        u_char                  drawing;
};


typedef struct {

        int                     tot_x;
        int                     tot_y;
        int                     spr_y;
        int                     spr_x;
        u_short                 addr;
        u_short                 pal;
        u_char                  pri;
        u_char                 *ptr;

} SprDef;



extern struct   _vdp_           vdp;

extern u_long                   vdp_render;
extern u_long                   frame_skip;

extern u_char                   scrl_a_enable;
extern u_char                   scrl_b_enable;
extern u_char                   window_enable;
extern u_char                   sprs_enable;
extern u_char                   scrl_ln_enable;
extern u_char                   timing_enable;
extern u_char                   rf_enable;
extern u_char                   wait_sync;

extern u_long                   vdp_run;

extern u_char                   vid_buffer[0x30000];


extern u_long                   cnt_dma_busy;
extern u_long                   cnt_vert_intr;
extern u_long                   cnt_vert_blkf;
extern u_long                   cnt_vert_blk;

void ResetVDP (void);
void RunVDP (void);
void RunVDPIntr (void);
void GoVDP (void);
FLAG CheckKeyb (void);

u_long ReadVDPPort (u_long addr, u_short size);
void WriteVDPPort (u_long addr, u_short size, u_long to_write);

void WriteToVDPMem (char *dest, u_short cnt, u_long to_write);
u_long LoadFromVDPMem (char *from, u_short size);

void CtrlVDPReg (u_short reg);
void DoDMA (void);
void DoCRAM (void);

void RenderVDP (void);
void RenderVDPOverall (void);
void RenderVDPCell (void);
void RenderVDPLine (void);
void RenderVDPLineRaster (void);

void ShowWindow (void);
void ShowSprs (void);
void PutSprA (u_long first, u_long second);
void PutSprB (u_long first, u_long second);
void PutSprC (u_long first, u_long second);
void PutSprD (u_long first, u_long second);

void ShowVGA (void);
void ShowVGAFull (void);



#endif


